-- Airstrike Arsenal script by Cyber
-- Based on minigun script by Tuxedo Labs

function init()
	RegisterTool("BarrageStrike", "Airstrike designator", "MOD/vox/BarrageStrike.vox")
	SetBool("game.tool.BarrageStrike.enabled", true)
	SetFloat("game.tool.BarrageStrike.ammo", 5)
	nosmoke = GetBool("savegame.mod.nosmoke")
	nosound = GetBool("savegame.mod.nosound")
	noshock = GetBool("savegame.mod.noshock")
	
	mode = 0
	coolDown = 0
	smoke = 0
	AirstikeEffectstime = -1
	ModeWait = 0
	AirstrikeLoc = 0
	AirstikeEffectscount = 0
	canfire = 1
	lighttime = 0
	MoabTime = 0
	playsnd = 0
	shockwave = 0
	closetomoab = 0
	light = 330
	rocketsound = LoadSound("MOD/snd/rocketfire.ogg")
	bunkersound = LoadSound("MOD/snd/bunkerfire.ogg")
	moabapp = LoadSound("MOD/snd/moabapp.ogg")
	moabsnd = LoadSound("MOD/snd/moabsnd.ogg")
	moabsndapp = LoadSound("MOD/snd/moabsndapp.ogg")
	moabsndboom = LoadSound("MOD/snd/moabsndboom.ogg")
	plbustsnd = LoadSound("MOD/snd/plbustsnd.ogg")
	radiosnd = LoadSound("MOD/snd/engtrgt.ogg")
	minisnd = LoadSound("MOD/snd/minisnd.ogg")
	
	oldPipePos = Vec()
	particleTimer = 0
		
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function tick(dt)

    AirstikeEffectstime = AirstikeEffectstime - dt
	ModeWait = ModeWait - dt
	lighttime = lighttime - dt
	MoabTime = MoabTime - dt
	lighton()
	AirstikeEffects()
	ChangeMode()
	moabdrop()

	if GetString("game.player.tool") == "BarrageStrike" then
			
		local ct = GetCameraTransform()
		
		if canfire == 0 then
			local b = GetToolBody()
				local shapes = GetBodyShapes(b)
		
				if b ~= body then
					body = b
					t0 = GetShapeLocalTransform(shapes[2])
				end

				t = TransformCopy(t0)
				t.pos = VecAdd(t.pos, Vec(0,0,3))
				SetShapeLocalTransform(shapes[2], t)
		else
			local b = GetToolBody()
			local shapes = GetBodyShapes(b)
			if b ~= body then
				body = b
				    t0 = GetShapeLocalTransform(shapes[2])
			end

			t = TransformCopy(t0)
			t.pos = VecAdd(t.pos, Vec(0,0,0))
			SetShapeLocalTransform(shapes[2], t)
		end
        		
		if GetBool("game.player.canusetool") and InputDown("usetool") and canfire == 1 and lighttime < 0 then
		        
			if coolDown < 0 then
				local t = GetCameraTransform()
				local fwd = TransformToParentVec(t, Vec(0, 0, -1))
				local maxDist = 10000
				local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
				if not hit then
					dist = maxDist
				end
				
				local e = VecAdd(t.pos, VecScale(fwd, dist))
	           				
				if hit then				
					AirstrikeLoc = e
					AirstikeEffectstime = 4
					AirstikeEffectscount = 1
					canfire = 0
					if not nosound then
						PlaySound(radiosnd)	
					end
				end

				smoke = math.min(1.0, smoke + .5)
				coolDown = 1

			end			
	    end
					
		coolDown = coolDown - dt
		
	end		
end

function lighton()
	
	if lighttime > 1.6 and lighttime < 1.8 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-32,32), math.random(10,20), math.random(-32,32)))
			PointLight(r, 8, 3, 0, 330)				
		end
	elseif lighttime > 1.4 and lighttime < 1.6 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-29,29), math.random(11,21), math.random(-29,29)))
			PointLight(r, 8, 3, 0, 297)
		end 	
	elseif lighttime > 1.2 and lighttime < 1.4 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-26,26), math.random(12,22), math.random(-26,26)))
			PointLight(r, 8, 3, 0, 264)
		end 	
	elseif lighttime > 1.0 and lighttime < 1.2 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-23,23), math.random(13,23), math.random(-23,23)))
			PointLight(r, 8, 3, 0, 231)
		end 	
	elseif lighttime > 0.8 and lighttime < 1.0 then
		if not nosmoke then
			for i=0, 50 do
				r = VecAdd (AirstrikeLoc, Vec(math.random(-20,20), math.random(14,24), math.random(-20,20)))
				PointLight(r, 8, 3, 0, 198)
			end	
		end
		if shockwave == 0 and not noshock then
			if closetomoab == 0 and not nosound then
				PlaySound(moabsndboom)
			end	
			local maxDistTwo = 1500
			local c = TransformToParentVec(AirstrikeLoc, Vec(0, 0, 0))
			local mi = VecAdd(c, Vec(-maxDistTwo/2, -maxDistTwo/2, -maxDistTwo/2))
			local ma = VecAdd(c, Vec(maxDistTwo/2, maxDistTwo/2, maxDistTwo/2))
			QueryRequire("physical dynamic")
			local bodies = QueryAabbBodies(mi, ma)	
			for i=1,#bodies do
				local b = bodies[i]
				local b = bodies[i]
				local vel = Vec(2,3,2)
				SetBodyVelocity(b, vel)
			end	
			shockwave = 1
			closetomoab = 0
		end
		
	elseif lighttime > 0.6 and lighttime < 0.8 then
	    if not nosmoke then
			for i=0, 50 do
				r = VecAdd (AirstrikeLoc, Vec(math.random(-17,17), math.random(15,25), math.random(-17,17)))
				PointLight(r, 8, 3, 0, 165)
			end 
		end
		shockwave = 0
	elseif lighttime > 0.4 and lighttime < 0.6 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-17,17), math.random(16,26), math.random(-17,17)))
			PointLight(r, 8, 3, 0, 132)
		end 	
	elseif lighttime > 0.2 and lighttime < 0.4 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-15,15), math.random(17,27), math.random(-15,15)))
			PointLight(r, 8, 3, 0, 122)
		end 	
	elseif lighttime < 0.2 and lighttime > 0 and not nosmoke then
		for i=0, 50 do
			r = VecAdd (AirstrikeLoc, Vec(math.random(-12,12), math.random(18,28), math.random(-12,12)))
			PointLight(r, 8, 3, 0, 112)
		end 
	end
	
end

function moabdrop()
	if MoabTime > 0 and MoabTime < 0.1 then 
		for i=0, 2 do
			ParticleType("plain")
			ParticleCollide(1)
			ParticleEmissive(1, 0)
			ParticleGravity(-70)
			ParticleRadius(1.0)
			ParticleColor(2,0.5,0)
			ParticleSticky(1)
			r = VecAdd (AirstrikeLoc, Vec(0, 350, 0))
			SpawnParticle(r, VecAdd(0,0,0), 3.5)
			r = VecAdd (AirstrikeLoc, Vec(0, 355, -1.2))
			SpawnParticle(r, VecAdd(0,0,0), 3.5)
			r = VecAdd (AirstrikeLoc, Vec(0, 355, 1.2))
			SpawnParticle(r, VecAdd(0,0,0), 3.5)
			ParticleSticky(0)
		end		
	end	
end 

function ChangeMode()

    local body = GetPlayerGrabBody()
	local shape = GetPlayerGrabShape()

    if GetString("game.player.tool") == "BarrageStrike" and InputDown("rmb") and canfire == 1 and shape == 0 and body == 0 then
	    if mode <= 5 and ModeWait < 0 then
		    mode = mode + 1
			ModeWait = .3
		elseif mode > 5 and ModeWait < 0 then
            mode = 0
			ModeWait = .3
        end			
	end
	if GetString("game.player.tool") == "BarrageStrike" and InputDown("mmb") and canfire == 1 and shape == 0 and body == 0 then
	    if mode >= 1 and ModeWait < 0 then
		    mode = mode - 1
			ModeWait = .3
		elseif mode < 1 and ModeWait < 0 then
            mode = 6
			ModeWait = .3
        end			
	end
end

function draw()
	if GetString("game.player.tool") == "BarrageStrike" and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if canfire == 1 and lighttime < 0 then
			    if mode == 0 then
			    UiText("Standard Barrage")
				elseif mode == 1 then
				UiText("Heavy Barrage")
				elseif mode == 2 then
				UiText("Bunker Buster")
				elseif mode == 3 then
				UiText("Wide Heavy Barrage")
				elseif mode == 4 then
				UiText("Minigun Fire")
				elseif mode == 5 then
				UiText("World Buster")
				elseif mode == 6 then
				UiText("M.O.A.B")
				end
			else
			    UiText("RELOADING")
			end 
		UiPop()
	end
end

function AirstikeEffects()

	if AirstikeEffectstime > 0 then
		PointLight(AirstrikeLoc, 8, 0, 0, 1)
	end 

    if AirstikeEffectstime > 3.9 and AirstikeEffectstime < 4 then
	    if playsnd == 0 and not nosound then
		    if mode == 0 or mode == 1 or mode == 3 then
				PlaySound(rocketsound)
			end
			if mode == 2  then
				PlaySound(bunkersound)
			end
			if mode == 4 then
				PlaySound(minisnd)
			end
			if mode == 6 then
				PlaySound(moabapp)
			end
			playsnd = 1
		end	
	    if mode == 6 then
			MoabTime = 0.3
		end	
	end 

    if AirstikeEffectstime > 0 and AirstikeEffectstime < 0.2 then
	    if AirstikeEffectscount == 1 then
			 
            if mode == 0 then	-- standard barrage		 
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(100,350)
			    for i=0, 12 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    Shoot(r, Vec(0, -1, 0), "rocket", 4, 5000)
				    RandDirOne = math.random(-15,15)
			        RandDirTwo = math.random(-15,15)
			        RandDirThree = math.random(100,350)
				end	
			elseif mode == 1 then		-- heavy barrage	 
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(100,350)
			    for i=0, 35 do  
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    Shoot(r, Vec(0, -1, 0), "rocket", 4, 5000)
				    RandDirOne = math.random(-15,15)
			        RandDirTwo = math.random(-15,15)
			        RandDirThree = math.random(100,350)
				end	
			elseif mode == 2 then	-- bunker buster		 
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(100,110)
			    for i=0, 100 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    Shoot(r, Vec(0, -1, 0), "rocket", 4, 5000)
			        RandDirThree = math.random(100,110)
				end	
            elseif mode == 3 then	--wide heavy barrage		 
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(100,350)
			    for i=0, 35 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    Shoot(r, Vec(0, -1, 0), "rocket", 4, 5000)
				    RandDirOne = math.random(-45,45)
			        RandDirTwo = math.random(-45,45)
			        RandDirThree = math.random(100,350)
				end	
            elseif mode == 4 then	--minigun		 
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(450,900)
			    for i=0, 110 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    Shoot(r, Vec(0, -1, 0), "bullet", 1, 5000)
				    RandDirOne = math.random(-2,2)
			        RandDirTwo = math.random(-2,2)
			        RandDirThree = math.random(450,900)
				end	
			elseif mode == 5 then	-- world buster	
				
				local p = GetPlayerPos()
				local a = AirstrikeLoc
				local x = VecSub(p, a)
				local px = VecLength(x)
				
				if px < 500 then
				    SetPlayerHealth(0.2) 	
				end
				if not nosound then
					PlaySound(plbustsnd)
				end
			    local maxDistTwo = 1500
				local c = TransformToParentPoint(AirstrikeLoc, Vec(0, 0, 0))
				local mi = VecAdd(c, Vec(-maxDistTwo/2, -maxDistTwo/2, -maxDistTwo/2))
				local ma = VecAdd(c, Vec(maxDistTwo/2, maxDistTwo/2, maxDistTwo/2))
				QueryRequire("static")
				local bodies = QueryAabbBodies(mi, ma)	
				for i=1,#bodies do
					local b = bodies[i]
					Delete(b)
				end	
				QueryRequire("physical dynamic")
				local bodies = QueryAabbBodies(mi, ma)	
				for i=1,#bodies do
					local b = bodies[i]
					local vel = Vec(2,10,2)
					SetBodyVelocity(b, vel)
				for i=0, 2 do 	
                    if not nosmoke then				
						ParticleType("plain")
						ParticleCollide(0)
						ParticleDrag(1)
						ParticleGravity(-3)
						ParticleRadius(8.0)
						ParticleColor(.5,.5,.5)
						ParticleRotation(.2)
						r = VecAdd (AirstrikeLoc, Vec(math.random(-200,200), math.random(-200,200), math.random(-200,200)))
						SpawnParticle(r, VecAdd(0,0,0), 15.0)	
						PointLight(r, 1, 1, 0, 80)		
                    end					
				end	
				end	
            elseif mode == 6 then	--M.O.A.B
			
				lighttime = 1.79
				
			    local p = GetPlayerPos()
				local a = AirstrikeLoc
				local x = VecSub(p, a)
				local px = VecLength(x)
				
				if px < 55 then
				    SetPlayerHealth(0.0) 
					closetomoab = 1
				end	
				if not nosound and closetomoab == 0 then
					if not noshock then
						PlaySound(moabsndapp)
					else
						PlaySound(moabsnd)
					end
				end
				Explosion(r, 4)			
			    RandDirOne = 0
			    RandDirTwo = 0
			    RandDirThree = math.random(10,15)
			    for i=0, 100 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    MakeHole(r, 11.0, 10.0, 9.0)
					Paint(r, 5, "explosion", 1)
				    RandDirOne = math.random(-10,10)
			        RandDirTwo = math.random(-10,10)
			        RandDirThree = math.random(-10,10)
				end	
				for i=0, 500 do 
				    r = VecAdd (AirstrikeLoc, Vec(RandDirOne, RandDirThree, RandDirTwo))
				    MakeHole(r, 11.0, 10.0, 9.0)
					Paint(r, 5, "explosion", 1)
				    RandDirOne = math.random(-27,27)
			        RandDirTwo = math.random(-27,27)
			        RandDirThree = math.random(-27,27)
				end		
								
				if not nosmoke then
					ParticleType("plain")
					ParticleCollide(0)
					ParticleRadius(8.0)
					ParticleDrag(1)
					ParticleEmissive(0.1, 0)
					ParticleColor(.5,.5,.5)
					ParticleAlpha(5.0 , 0.0)
					
					for i=0, 110 do
						r = VecAdd (AirstrikeLoc, Vec(math.random(-30,30), math.random(-10,5), math.random(-30,30)))
						SpawnParticle(r, VecAdd(0,0,0), 15.0)
						r = VecAdd (AirstrikeLoc, Vec(math.random(-30,30), math.random(-10,5), math.random(-30,30)))
						SpawnParticle(r, VecAdd(0,0,0), 15.0)
						SpawnFire(r)	
						ParticleRadius(3.0)	
					end	
					
					ParticleRadius(5.0)

					r = VecAdd (AirstrikeLoc, Vec(0, 3, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
					r = VecAdd (AirstrikeLoc, Vec(0, 6, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
					r = VecAdd (AirstrikeLoc, Vec(0, 9, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
					r = VecAdd (AirstrikeLoc, Vec(0, 12, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
					ParticleGravity(1)
					for i=0, 2 do
						r = VecAdd (AirstrikeLoc, Vec(0, 9, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 12, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 15, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 18, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 21, 0))
					end

					ParticleGravity(10)
					ParticleRadius(8.0)
					ParticleRotation(.2)
					
					for i=0, 5 do
						r = VecAdd (AirstrikeLoc, Vec(8, 9, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 9, 8))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						ParticleRotation(-.2)
						r = VecAdd (AirstrikeLoc, Vec(-8, 9, 0))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
						r = VecAdd (AirstrikeLoc, Vec(0, 9, -8))
						SpawnParticle(r, VecAdd(0,0,0), 12.0)
					end

					r = VecAdd (AirstrikeLoc, Vec(0, 9, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
					r = VecAdd (AirstrikeLoc, Vec(0, 12, 0))
					SpawnParticle(r, VecAdd(0,0,0), 12.0)
				end
			end

			playsnd = 0
			canfire = 1
			AirstikeEffectscount = 0
		end 
    end						
end